VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_rulers_grid"
   ClientHeight    =   3090
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   206
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   312
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   1095
      Left            =   360
      ScaleHeight     =   69
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   85
      TabIndex        =   2
      Top             =   360
      Width           =   1335
   End
   Begin VB.PictureBox picTopRuler 
      BackColor       =   &H00FFFFFF&
      Height          =   240
      Left            =   360
      ScaleHeight     =   12
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   85
      TabIndex        =   1
      Top             =   0
      Width           =   1335
   End
   Begin VB.PictureBox picLeftRuler 
      BackColor       =   &H00FFFFFF&
      Height          =   1695
      Left            =   0
      ScaleHeight     =   109
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   12
      TabIndex        =   0
      Top             =   360
      Width           =   240
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptionsShowGrid 
         Caption         =   "&Show Grid"
         Checked         =   -1  'True
      End
      Begin VB.Menu mnuOptionsSnapToGrid 
         Caption         =   "S&nap to Grid"
         Checked         =   -1  'True
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Drawing parameters.
Private m_GridX As Integer
Private m_GridY As Integer
Private m_PageWid As Integer
Private m_PageHgt As Integer
Private m_ShadowThickness As Integer

' Pens.
Private m_ColorOldLine As OLE_COLOR
Private m_ColorNewLine As OLE_COLOR
Private m_ColorGrid As OLE_COLOR
Private m_ColorRulerNormal As OLE_COLOR
Private m_ColorRulerDrawing As OLE_COLOR

' Options.
Private m_ShowGrid As Boolean
Private m_SnapToGrid As Boolean

' For drawing a new line.
Private m_Drawing As Boolean
Private m_X1 As Integer
Private m_Y1 As Integer
Private m_X2 As Integer
Private m_Y2 As Integer

' For showing position on the rulers.
Private m_MouseX As Integer
Private m_MouseY As Integer

' Existing lines.
Private Type Segment
    x1 As Integer
    y1 As Integer
    x2 As Integer
    y2 As Integer
End Type
Private m_NumSegments As Integer
Private m_Segments() As Segment

Private Sub Form_Load()
    InitializeOptions

    m_ShowGrid = mnuOptionsShowGrid.Checked
    m_SnapToGrid = mnuOptionsSnapToGrid.Checked
End Sub

Private Sub InitializeOptions()
    ' Drawing parameters.
    m_GridX = 10
    m_GridY = 10
    m_PageWid = 400
    m_PageHgt = 300
    m_ShadowThickness = 20

    ' Pens.
    m_ColorOldLine = vbBlack
    m_ColorNewLine = vbRed
    m_ColorGrid = vbBlack
    m_ColorRulerNormal = vbBlue
    m_ColorRulerDrawing = m_ColorNewLine

    ' Options.
    m_ShowGrid = False
    m_SnapToGrid = False

    ' For drawing a new line.
    m_Drawing = False

    ' For showing position on the rulers.
    m_MouseX = -10
    m_MouseY = -10

    ' Existing lines.
    m_NumSegments = 0
End Sub

' Arrange controls.
Private Sub Form_Resize()
Dim wid As Integer
Dim hgt As Integer

    wid = ScaleWidth - picLeftRuler.Width - 3
    If wid < 10 Then wid = 10
    hgt = ScaleHeight - picTopRuler.Height - 3
    If hgt < 10 Then hgt = 10

    picTopRuler.Move picLeftRuler.Width + 2, 0, wid
    picLeftRuler.Move 0, picTopRuler.Height + 2, picLeftRuler.Width, hgt
    picCanvas.Move picLeftRuler.Width + 2, picTopRuler.Height + 2, wid, hgt
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub mnuOptionsShowGrid_Click()
    m_ShowGrid = Not m_ShowGrid
    mnuOptionsShowGrid.Checked = m_ShowGrid

    picCanvas.Refresh
End Sub

Private Sub mnuOptionsSnapToGrid_Click()
    m_SnapToGrid = Not m_SnapToGrid
    mnuOptionsSnapToGrid.Checked = m_SnapToGrid
End Sub

' Start drawing a line.
Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' Only on left mouse down.
    If Button <> vbLeftButton Then Exit Sub
    m_Drawing = True

    ' Start drawing.
    m_X1 = x
    m_Y1 = y
    SnapToGrid m_X1, m_Y1
    m_X2 = m_X1
    m_Y2 = m_Y1

    picCanvas.Refresh
    ShowMousePosition m_X2, m_Y2
End Sub

' Continue drawing.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    m_X2 = x
    m_Y2 = y
    SnapToGrid m_X2, m_Y2

    ' Show the mouse position on the rulers.
    ShowMousePosition m_X2, m_Y2

    ' Redraw.
    If m_Drawing Then picCanvas.Refresh
End Sub

' Finish drawing.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Not m_Drawing Then Exit Sub
    m_Drawing = False

    ' Show the mouse position in the non-drawing color.
    ShowMousePosition m_X2, m_Y2

    ' Save the new line.
    m_NumSegments = m_NumSegments + 1
    ReDim Preserve m_Segments(1 To m_NumSegments)
    m_Segments(m_NumSegments).x1 = m_X1
    m_Segments(m_NumSegments).y1 = m_Y1
    m_Segments(m_NumSegments).x2 = m_X2
    m_Segments(m_NumSegments).y2 = m_Y2

    picCanvas.Refresh
End Sub

' Draw the lines.
Private Sub picCanvas_Paint()
Dim x, y, i As Integer

    picCanvas.Cls

    ' Draw the grid.
    If m_ShowGrid Then
        For x = 0 To picCanvas.ScaleWidth Step m_GridX
            For y = 0 To picCanvas.ScaleHeight Step m_GridY
                picCanvas.PSet (x, y), m_ColorGrid
            Next y
        Next x
    End If

    ' Draw existing lines.
    For i = 1 To m_NumSegments
        picCanvas.Line (m_Segments(i).x1, m_Segments(i).y1)-(m_Segments(i).x2, m_Segments(i).y2), m_ColorOldLine
    Next i

    ' Draw the new line.
    If m_Drawing Then
        picCanvas.Line (m_X1, m_Y1)-(m_X2, m_Y2), m_ColorNewLine
    End If
End Sub
' Snap the point to the nearest grid location.
Private Sub SnapToGrid(ByRef x As Integer, ByRef y As Integer)
Dim ix As Integer
Dim iy As Integer

    ' If grid snap is off, do nothing.
    If Not m_SnapToGrid Then Exit Sub

    ix = CInt(x / m_GridX)
    iy = CInt(y / m_GridY)
    x = ix * m_GridX
    y = iy * m_GridY
End Sub
' Show the mouse position on the rulers.
Private Sub ShowMousePosition(ByVal x As Integer, ByVal y As Integer)
    m_MouseX = x
    m_MouseY = y
    picTopRuler.Refresh
    picLeftRuler.Refresh
End Sub

' Draw the left ruler.
Private Sub picLeftRuler_Paint()
Dim x1 As Integer
Dim x2 As Integer
Dim x3 As Integer
Dim x4 As Integer
Dim y As Integer
Dim i As Integer

    picLeftRuler.Cls

    x1 = picLeftRuler.ScaleWidth
    x2 = (2 * picLeftRuler.ScaleWidth) \ 3
    x3 = picLeftRuler.ScaleWidth \ 3
    x4 = 0
    y = 0
    For i = 0 To picLeftRuler.ScaleHeight \ m_GridY
        If i Mod 10 = 0 Then
            picLeftRuler.Line (x1, y)-(x4, y), m_ColorGrid
        ElseIf i Mod 5 = 0 Then
            picLeftRuler.Line (x1, y)-(x3, y), m_ColorGrid
        Else
            picLeftRuler.Line (x1, y)-(x2, y), m_ColorGrid
        End If
        y = y + m_GridY
    Next i

    ' Show the mouse position.
    If m_Drawing Then
        picLeftRuler.Line (x1, m_MouseY)-(x4, m_MouseY), m_ColorRulerDrawing
    Else
        picLeftRuler.Line (x1, m_MouseY)-(x4, m_MouseY), m_ColorRulerNormal
    End If
End Sub

' Draw the top ruler.
Private Sub picTopRuler_Paint()
Dim y1 As Integer
Dim y2 As Integer
Dim y3 As Integer
Dim y4 As Integer
Dim x As Integer
Dim i As Integer

    picTopRuler.Cls

    y1 = picTopRuler.ScaleHeight
    y2 = (2 * picTopRuler.ScaleHeight) \ 3
    y3 = picTopRuler.ScaleHeight \ 3
    y4 = 0
    x = 0
    For i = 0 To picTopRuler.ScaleWidth \ m_GridX
        If i Mod 10 = 0 Then
            picTopRuler.Line (x, y1)-(x, y4), m_ColorGrid
        ElseIf i Mod 5 = 0 Then
            picTopRuler.Line (x, y1)-(x, y3), m_ColorGrid
        Else
            picTopRuler.Line (x, y1)-(x, y2), m_ColorGrid
        End If
        x = x + m_GridX
    Next i

    ' Show the mouse position.
    If m_Drawing Then
        picTopRuler.Line (m_MouseX, y1)-(m_MouseX, 0), m_ColorRulerDrawing
    Else
        picTopRuler.Line (m_MouseX, y1)-(m_MouseX, 0), m_ColorRulerNormal
    End If
End Sub
